from enum import Enum


class TemporalGranularity(Enum):
    # Absolute date
    SECOND = "SECOND"  # "FORMAT_TIMESTAMP('%Y-%m-%d %H:%M:%S', CAST(%VALUE% AS TIMESTAMP))"
    SECONDS = "SECONDS"
    MINUTE = "MINUTE"  # "FORMAT_TIMESTAMP('%Y-%m-%d %H:%M', CAST(%VALUE% AS TIMESTAMP))"
    MINUTES = "MINUTES"
    HOUR = "HOUR"  # "FORMAT_TIMESTAMP('%Y-%m-%d %H', CAST(%VALUE% AS TIMESTAMP))"
    HOURS = "HOURS"
    DAY = "DAY"  # "FORMAT_TIMESTAMP('%Y-%m-%d', CAST(%VALUE% AS TIMESTAMP))"
    DAYS = "DAYS"
    WEEK = "WEEK"  # "FORMAT_TIMESTAMP('%Y-w%W', CAST(%VALUE% AS TIMESTAMP))"
    WEEKS = "WEEKS"
    MONTH = "MONTH"  # "FORMAT_TIMESTAMP('%Y-%m', CAST(%VALUE% AS TIMESTAMP))"
    MONTHS = "MONTHS"
    YEAR = "YEAR"  # "FORMAT_TIMESTAMP('%Y', CAST(%VALUE% AS TIMESTAMP))"
    YEARS = "YEARS"
    DECADE = "DECADE"  # "FORMAT_TIMESTAMP('%Y', CAST(%VALUE% AS TIMESTAMP))"  # Needs additional logic
    DECADES = "DECADES"  # Not provided
    CENTURY = "CENTURY"  # "FORMAT_TIMESTAMP('%Y', CAST(%VALUE% AS TIMESTAMP))"  # Needs additional logic
    CENTURIES = "CENTURIES"  # Not provided
    MILLENNIUM = "MILLENNIUM"  # Not provided
    MILLENNIA = "MILLENNIA"  # Not provided

    # Relative date
    BIMESTER = "BIMESTER"  # "FORMAT_TIMESTAMP('%Y-b%b', CAST(%VALUE% AS TIMESTAMP))"
    TRIMESTER = "TRIMESTER"  # "FORMAT_TIMESTAMP('%Y-t%t', CAST(%VALUE% AS TIMESTAMP))"
    QUARTER = "QUARTER"  # "FORMAT_TIMESTAMP('%Y-q%q', CAST(%VALUE% AS TIMESTAMP))"
    SEMESTER = "SEMESTER"  # "FORMAT_TIMESTAMP('%Y-s%s', CAST(%VALUE% AS TIMESTAMP))"
    YEAR_DAY = "YEAR_DAY"  # "FORMAT_TIMESTAMP('%j', CAST(%VALUE% AS TIMESTAMP))"
    MONTH_DAY = "MONTH_DAY"  # "FORMAT_TIMESTAMP('%d', CAST(%VALUE% AS TIMESTAMP))"
    MONTH_YEAR = "MONTH_YEAR"  # "FORMAT_TIMESTAMP('%m', CAST(%VALUE% AS TIMESTAMP))"
    WEEK_DAY = "WEEK_DAY"  # "FORMAT_TIMESTAMP('%u', CAST(%VALUE% AS TIMESTAMP))"
    WEEK_YEAR = "WEEK_YEAR"  # "FORMAT_TIMESTAMP('w%W', CAST(%VALUE% AS TIMESTAMP))"
    WEEK_MONTH = "WEEK_MONTH"  # "FORMAT_TIMESTAMP('%Y-w%W', CAST(%VALUE% AS TIMESTAMP))"
    DAY_HOURS = "DAY_HOURS"  # "FORMAT_TIMESTAMP('%Y-%m-%d %H', CAST(%VALUE% AS TIMESTAMP))"
    DAY_MINUTES = "DAY_MINUTES"  # "FORMAT_TIMESTAMP('%Y-%m-%d %H:%M', CAST(%VALUE% AS TIMESTAMP))"
    HOUR_MINUTES = "HOUR_MINUTES"  # "FORMAT_TIMESTAMP('%Y-%m-%d %H:%M', CAST(%VALUE% AS TIMESTAMP))"
    HOUR_SECONDS = "HOUR_SECONDS"  # "FORMAT_TIMESTAMP('%Y-%m-%d %H:%M:%S', CAST(%VALUE% AS TIMESTAMP))"
    DAY_SECONDS = "DAY_SECONDS"  # "FORMAT_TIMESTAMP('%Y-%m-%d %H:%M:%S', CAST(%VALUE% AS TIMESTAMP))"
    MINUTE_SECONDS = "MINUTE_SECONDS"  # "FORMAT_TIMESTAMP('%Y-%m-%d %H:%M:%S', CAST(%VALUE% AS TIMESTAMP))"
